<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import AdminProductModule from "~/store/adminCollection";
import { api } from "~/common/constaint";
import _ from "lodash";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class AdminPromotionComponent extends Vue {
  adminProduct = getModule(AdminProductModule, this.$store);

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;
  page = 1;

  listDiscountType = [
    { name: "Percent", value: 1 },
    { name: "Value", value: 2 },
  ];
  listAllProduct = [];
  listProduct = [];
  listCollection = [];
  listIds = [];

  selectedAll = false;
  loadingTable = false;
  loading = false;

  listCollectionId = [];
  listProductId = [];

  promotion = {
    name: "",
    discountType: 1,
    value: 0,
    from: 0,
    to: 0,
    status: 0,
    promotionType: "1",
  };

  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = momentz().endOf("month").format("YYYY-MM-DD");

  get fromVn() {
    const fromHcm = momentz
      .tz(this.dateStart, "YYYY-MM-DD", "Asia/Ho_Chi_Minh")
      .unix();
    return fromHcm;
  }

  get toVn() {
    const toHcm = momentz
      .tz(this.dateEnd, "YYYY-MM-DD", "Asia/Ho_Chi_Minh")
      .unix();
    return toHcm;
  }

  mounted() {
    this.onGetPromotion();
  }

  async onGetPromotion() {
    try {
      const response = await this.$api.promotion.get();
      if (response?.data) {
        const {
          name,
          discountType,
          value,
          listCollectionId,
          listProductId,
          promotionType,
          from,
          to,
          status,
        } = response.data;
        this.promotion = {
          name,
          discountType,
          value,
          promotionType: promotionType.toString(),
          status,
          from: moment.unix(from).format("YYYY-MM-DD"),
          to: moment.unix(to).format("YYYY-MM-DD"),
        };
        this.dateStart = moment.unix(from).format("YYYY-MM-DD");
        this.dateEnd = moment.unix(to).format("YYYY-MM-DD");
        if (promotionType === 2 && listCollectionId.length) {
          this.listIds = listCollectionId;
        } else if (promotionType === 3 && listProductId.length) {
          this.listIds = listProductId;
        }
        this.listCollectionId = listCollectionId;
        this.listProductId = listProductId;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListCollection() {
    try {
      this.loadingTable = true;
      const response = await this.$api.collection.getListAdmin(this.config);
      if (response.data) {
        this.listCollection = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListProduct() {
    try {
      this.loadingTable = true;
      const response = await this.$api.product.getListAdmin(this.config);
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onUpdatePromotion() {
    try {
      // && this.promotion.value
      if (!this.promotion.name) {
        return this.$pushNotification.error("Please complete all information");
      }
      // else if (this.promotion.value < 1) {
      // 	return this.$pushNotification.error(
      // 		"Promotion value cannot be less than 1"
      // 	);
      // } else if (
      // 	this.promotion.promotionType === "2" &&
      // 	!this.listIds.length
      // ) {
      // 	return this.$pushNotification.error(
      // 		"Please select a collection"
      // 	);
      // } else if (
      // 	this.promotion.promotionType === "3" &&
      // 	!this.listIds.length
      // ) {
      // 	return this.$pushNotification.error("Please select a product");
      // }
      this.loading = true;
      const { name, discountType, value, status, promotionType } =
        this.promotion;
      const payload = {
        name,
        discountType,
        value,
        from: this.fromVn,
        to: this.toVn,
        status: status ? 1 : 0,
        promotionType: 1,
      };
      // parseInt(promotionType)
      // if (promotionType === "2") {
      // 	//@ts-ignore
      // 	payload.listCollectionId = this.listIds;
      // } else if (promotionType === "3") {
      // 	//@ts-ignore
      // 	payload.listProductId = this.listIds;
      // }
      await this.$api.promotion.update(payload);
      this.$pushNotification.success("Changed promotion successfully");
      this.onGetPromotion();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
    if (this.promotion.promotionType === "2") {
      this.onGetListCollection();
    } else if (this.promotion.promotionType === "3") {
      this.onGetListProduct();
    }
  }

  selectedAllProduct() {}

  selectedProduct(value: boolean) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentProduct];
    } else {
      //@ts-ignore
      const selectedCurrentProduct = this.listProduct
        //@ts-ignore
        .map((product) => product._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentProduct.includes(c)
      );
    }
  }

  selectedCollection(value: boolean) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentCollection = this.listCollection
        //@ts-ignore
        .map((collection) => collection._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentCollection];
    } else {
      //@ts-ignore
      const selectedCurrentCollection = this.listCollection
        //@ts-ignore
        .map((collection) => collection._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentCollection.includes(c)
      );
    }
  }

  convertImage(data: any) {
    if (data?.coverId?.imageUrl) {
      const { imageUrl } = data.coverId;
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  totalStockProduct(product: any) {
    let num = 0;
    if (product) {
      for (let sanpham of product.variant) {
        if (sanpham && sanpham.stock) {
          num += sanpham.stock;
        }
      }
    }
    return num || product.stock;
  }

  calcPrice(product: any) {
    let price = 0;
    if (product.variant.length) {
      for (let variant of product.variant) {
        price += variant.price;
      }
    } else {
      return product.price;
    }
    return price;
  }

  statusRunning(data: any, type: string) {
    if (type === "collection") {
      const id = data._id;
      if (this.listCollectionId.length) {
        const findId = this.listCollectionId.find(
          (collectionId: any) => collectionId === id
        );
        if (findId) {
          return true;
        } else {
          return false;
        }
      }
    } else if (type === "product") {
      const id = data._id;
      if (this.listProductId.length) {
        const findId = this.listProductId.find(
          (productId: any) => productId === id
        );
        if (findId) {
          return true;
        } else {
          return false;
        }
      }
    }
  }

  @Watch("promotion.promotionType")
  changedTypeAplliedProduct(value: string) {
    this.listIds = [];
    this.selectedAll = false;
    this.config = {
      page: 1,
      limit: 25,
      search: "",
    };
    this.totalPage = 0;
    this.page = 1;

    switch (value) {
      case "2":
        this.onGetListCollection();
        break;
      case "3":
        this.onGetListProduct();
    }
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: boolean, oldValue: boolean) {
    switch (this.promotion.promotionType) {
      case "1":
        this.selectedAllProduct();
      case "2":
        this.selectedCollection(value);
        break;
      case "3":
        this.selectedProduct(value);
    }
  }

  @Watch("config.page")
  changedPage() {
    switch (this.promotion.promotionType) {
      case "2":
        this.onGetListCollection();
        break;
      case "3":
        this.onGetListProduct();
    }
  }
}
</script>

<style></style>
